<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Hostdev Menu
 *
 * @Version 1.0
 * @author Eugeny Panikarowsky - evgenii_panikaro@mail.ru
 * @copyright © 2018 Eugeny Panikarowsky
 * $url http://hostdev.pw/
 *
*/

class Hostdev_Menu_Module extends Core_Module
{
	/**
	 * Module version
	 * @var string
	 */
	public $version = '1.0';

	/**
	 * Module date
	 * @var date
	 */
	public $date = '2018-08-21';
	/**
	 * Module name
	 * @var string
	 */
	protected $_moduleName = 'hostdev_menu';
	
    static public function onLoadSkinConfig($object, $args)
    {
        // Load config
        $aConfig = $object->getConfig();

		// Add module into 'content' section, see config.php
		if (!isset($aConfig['adminMenu']['hostdev'])) {
			$aConfig['adminMenu']['hostdev'] = array(
				'ico' => 'fa fa-code',
				'caption' => 'HostDev.pw',
				'modules' => array('hostdev_menu')
			);
		} else {
			$aConfig['adminMenu']['hostdev']['modules'][] = 'hostdev_menu';
		}
        // Set new config
        $object->setConfig($aConfig);
    }

	static public function _setEvents() {

		if (Core::moduleIsActive('hostdev_menu')) {
			Core_Event::attach('Skin_Bootstrap.onLoadSkinConfig', array('Hostdev_Menu_Module', 'onLoadSkinConfig'));
			
			Core_I18n::instance()->expandLng('structure',
				array(
					'changeAccess_success' => 'Статус доступности узла структуры успешно изменен',
				)
			);
		}
	}

	
	/**
	 * Constructor.
	 */
	public function __construct()
	{
		parent::__construct();

		Core_Event::attach('Core.onAfterInitConstants', array('Hostdev_Menu_Module','_setEvents'));
		
		$this->menu = array(
			array(
				'sorting'=>30,
				'block'=>0,
				'ico' => 'fa fa-list-ul',
				'name'=>Core::_('hostdev_menu.menu'),
				'href'=>"/admin/hostdev/menu/index.php",
				'onclick'=>"$.adminLoad({path: '/admin/hostdev/menu/index.php'}); return false"
			)
		);
	}

	public function install() {

		$oAdmin_Form = Core_Entity::factory('Admin_Form')->getByGuid('BB771E5B-15F2-6001-5127-20E1CF121D61');

		if (is_null($oAdmin_Form))
		{
			/**
			 * Создаем значения Admin_Word_Value
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'HostDev Меню Структура';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			/**
			 * Создаем форму
			 */
			$oAdmin_Form = Core_Entity::factory('Admin_Form');
			$oAdmin_Form->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form->on_page = 20;
			$oAdmin_Form->key_field = 'id';
			$oAdmin_Form->show_operations = 1;
			$oAdmin_Form->show_group_operations = 1;
			$oAdmin_Form->default_order_field = 'id';
			$oAdmin_Form->default_order_direction = 1;
			$oAdmin_Form->guid = 'BB771E5B-15F2-6001-5127-20E1CF121D61';
			$oAdmin_Form->save();

			/**
			 * Создаем поле формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'ID';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Field = Core_Entity::factory('Admin_Form_Field');
			$oAdmin_Form_Field->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Field->name = 'id';
			$oAdmin_Form_Field->sorting = 0;
			$oAdmin_Form_Field->ico = '';
			$oAdmin_Form_Field->type = 1;
			$oAdmin_Form_Field->format = '';
			$oAdmin_Form_Field->allow_sorting = 1;
			$oAdmin_Form_Field->allow_filter = 1;
			$oAdmin_Form_Field->editable = 0;
			$oAdmin_Form_Field->filter_type = 0;
			$oAdmin_Form_Field->class = '';
			$oAdmin_Form_Field->width = '45px;';
			$oAdmin_Form_Field->image = '';
			$oAdmin_Form_Field->link = '';
			$oAdmin_Form_Field->onclick = '';
			$oAdmin_Form_Field->list = '';
			$oAdmin_Form->add($oAdmin_Form_Field);

			/**
			 * Создаем поле формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'Название';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Field = Core_Entity::factory('Admin_Form_Field');
			$oAdmin_Form_Field->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Field->name = 'name';
			$oAdmin_Form_Field->sorting = 10;
			$oAdmin_Form_Field->ico = '';
			$oAdmin_Form_Field->type = 4;
			$oAdmin_Form_Field->format = '';
			$oAdmin_Form_Field->allow_sorting = 1;
			$oAdmin_Form_Field->allow_filter = 1;
			$oAdmin_Form_Field->editable = 0;
			$oAdmin_Form_Field->filter_type = 0;
			$oAdmin_Form_Field->class = '';
			$oAdmin_Form_Field->width = '';
			$oAdmin_Form_Field->image = '';
			$oAdmin_Form_Field->link = '/admin/hostdev/menu/structure/index.php?parent_id={id}&structure_menu_id={menu_id}';
			$oAdmin_Form_Field->onclick = '$.adminLoad({path: \'/admin/hostdev/menu/structure/index.php\', additionalParams: \'parent_id={id}&structure_menu_id={menu_id}\', windowId: \'{windowId}\'}); return false';
			$oAdmin_Form_Field->list = '';
			$oAdmin_Form->add($oAdmin_Form_Field);

			/**
			 * Создаем поле формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'Доступность';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Field = Core_Entity::factory('Admin_Form_Field');
			$oAdmin_Form_Field->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Field->name = 'enable';
			$oAdmin_Form_Field->sorting = 20;
			$oAdmin_Form_Field->ico = '';
			$oAdmin_Form_Field->type = 7;
			$oAdmin_Form_Field->format = '';
			$oAdmin_Form_Field->allow_sorting = 0;
			$oAdmin_Form_Field->allow_filter = 0;
			$oAdmin_Form_Field->editable = 0;
			$oAdmin_Form_Field->filter_type = 0;
			$oAdmin_Form_Field->class = 'text-center';
			$oAdmin_Form_Field->width = '150px';
			$oAdmin_Form_Field->image = '1=/admin/images/check.gif=enabled=fa fa-lightbulb-o fa-active
		0=/admin/images/not_check.gif=disabled=fa fa-lightbulb-o fa-inactive';
			$oAdmin_Form_Field->link = '/admin/hostdev/menu/structure/index.php?hostcms[action]=changeAccess&hostcms[checked][{dataset_key}][{id}]=0&structure_menu_id={menu_id}&structure_id={id}&parent_id={parent_id}';
			$oAdmin_Form_Field->onclick = '$.adminLoad({path: \'/admin/hostdev/menu/structure/index.php\',additionalParams: \'hostcms[checked][{dataset_key}][{id}]=0&structure_menu_id={menu_id}&structure_id={id}&parent_id={parent_id}\', action: \'changeAccess\', windowId: \'{windowId}\'}); return false';
			$oAdmin_Form_Field->list = '';
			$oAdmin_Form->add($oAdmin_Form_Field);

			/**
			 * Создаем действие формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'Изменить доступ';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Action = Core_Entity::factory('Admin_Form_Action');
			$oAdmin_Form_Action->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Action->name = 'changeAccess';
			$oAdmin_Form_Action->picture = '';
			$oAdmin_Form_Action->icon = '';
			$oAdmin_Form_Action->color = '';
			$oAdmin_Form_Action->single = '0';
			$oAdmin_Form_Action->group = '0';
			$oAdmin_Form_Action->sorting = '10';
			$oAdmin_Form_Action->dataset = '-1';
			$oAdmin_Form_Action->confirm = '0';
			$oAdmin_Form->add($oAdmin_Form_Action);
		}

		$oAdmin_Form = Core_Entity::factory('Admin_Form')->getByGuid('563DC24A-AD42-5BCB-2865-066AAD1F0A34');

		if (is_null($oAdmin_Form))
		{
			/**
			 * Создаем значения Admin_Word_Value
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'HostDev Меню';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			/**
			 * Создаем форму
			 */
			$oAdmin_Form = Core_Entity::factory('Admin_Form');
			$oAdmin_Form->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form->on_page = 20;
			$oAdmin_Form->key_field = 'id';
			$oAdmin_Form->show_operations = 1;
			$oAdmin_Form->show_group_operations = 1;
			$oAdmin_Form->default_order_field = 'id';
			$oAdmin_Form->default_order_direction = 1;
			$oAdmin_Form->guid = '563DC24A-AD42-5BCB-2865-066AAD1F0A34';
			$oAdmin_Form->save();

			/**
			 * Создаем поле формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'ID';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Field = Core_Entity::factory('Admin_Form_Field');
			$oAdmin_Form_Field->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Field->name = 'id';
			$oAdmin_Form_Field->sorting = 0;
			$oAdmin_Form_Field->ico = '';
			$oAdmin_Form_Field->type = 1;
			$oAdmin_Form_Field->format = '';
			$oAdmin_Form_Field->allow_sorting = 1;
			$oAdmin_Form_Field->allow_filter = 1;
			$oAdmin_Form_Field->editable = 0;
			$oAdmin_Form_Field->filter_type = 0;
			$oAdmin_Form_Field->class = '';
			$oAdmin_Form_Field->width = '45px;';
			$oAdmin_Form_Field->image = '';
			$oAdmin_Form_Field->link = '';
			$oAdmin_Form_Field->onclick = '';
			$oAdmin_Form_Field->list = '';
			$oAdmin_Form->add($oAdmin_Form_Field);

			/**
			 * Создаем поле формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'Название';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Field = Core_Entity::factory('Admin_Form_Field');
			$oAdmin_Form_Field->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Field->name = 'name';
			$oAdmin_Form_Field->sorting = 10;
			$oAdmin_Form_Field->ico = '';
			$oAdmin_Form_Field->type = 4;
			$oAdmin_Form_Field->format = '';
			$oAdmin_Form_Field->allow_sorting = 1;
			$oAdmin_Form_Field->allow_filter = 1;
			$oAdmin_Form_Field->editable = 0;
			$oAdmin_Form_Field->filter_type = 0;
			$oAdmin_Form_Field->class = '';
			$oAdmin_Form_Field->width = '';
			$oAdmin_Form_Field->image = '';
			$oAdmin_Form_Field->link = '/admin/hostdev/menu/structure/index.php?structure_menu_id={id}';
			$oAdmin_Form_Field->onclick = '$.adminLoad({path: \'/admin/hostdev/menu/structure/index.php\', additionalParams: \'structure_menu_id={id}\', windowId: \'{windowId}\'}); return false';
			$oAdmin_Form_Field->list = '';
			$oAdmin_Form->add($oAdmin_Form_Field);

			/**
			 * Создаем действие формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'Редактирование';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Action = Core_Entity::factory('Admin_Form_Action');
			$oAdmin_Form_Action->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Action->name = 'edit';
			$oAdmin_Form_Action->picture = '/admin/images/edit.gif';
			$oAdmin_Form_Action->icon = 'fa fa-pencil';
			$oAdmin_Form_Action->color = 'palegreen';
			$oAdmin_Form_Action->single = '1';
			$oAdmin_Form_Action->group = '0';
			$oAdmin_Form_Action->sorting = '0';
			$oAdmin_Form_Action->dataset = '-1';
			$oAdmin_Form_Action->confirm = '0';
			$oAdmin_Form->add($oAdmin_Form_Action);

			/**
			 * Создаем действие формы
			 */
			$oAdmin_Word = Core_Entity::factory('Admin_Word')->save();

			$oAdmin_Word_Value_RU = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_RU->admin_language_id = 1;
			$oAdmin_Word_Value_RU->name = 'Удалить';
			$oAdmin_Word->add($oAdmin_Word_Value_RU);

			$oAdmin_Word_Value_EN = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_EN->admin_language_id = 2;
			$oAdmin_Word_Value_EN->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_EN);

			$oAdmin_Word_Value_UA = Core_Entity::factory('Admin_Word_Value');
			$oAdmin_Word_Value_UA->admin_language_id = 3;
			$oAdmin_Word_Value_UA->name = '';
			$oAdmin_Word->add($oAdmin_Word_Value_UA);

			$oAdmin_Form_Action = Core_Entity::factory('Admin_Form_Action');
			$oAdmin_Form_Action->admin_word_id = $oAdmin_Word->id;
			$oAdmin_Form_Action->name = 'markDeleted';
			$oAdmin_Form_Action->picture = '/admin/images/delete.gif';
			$oAdmin_Form_Action->icon = 'fa fa-trash-o';
			$oAdmin_Form_Action->color = 'darkorange';
			$oAdmin_Form_Action->single = '1';
			$oAdmin_Form_Action->group = '1';
			$oAdmin_Form_Action->sorting = '10';
			$oAdmin_Form_Action->dataset = '-1';
			$oAdmin_Form_Action->confirm = '1';
			$oAdmin_Form->add($oAdmin_Form_Action);
		}
		$dumpfile = Core_File::read(dirname(__FILE__) . DIRECTORY_SEPARATOR .'install.sql');

		Sql_Controller::instance()->execute($dumpfile);
	}
	
	public function uninstall() {

	}




}