<?php

defined('HOSTCMS') || exit('HostCMS: access denied.');

/**
 * Hostdev Menu
 *
 * @Version 1.0
 * @author Eugeny Panikarowsky - evgenii_panikaro@mail.ru
 * @copyright © 2018 Eugeny Panikarowsky
 * $url http://hostdev.pw/
 *
*/

class HostDev_Menu_Structure_Model extends Structure_Model {

	/**
	 * Callback property
	 * @var int
	 */
	public $enable = NULL;	
	/**
	 * Name of the table
	 * @var string
	 */
	protected $_tableName = 'structures';
	
	/**
	 * Name of the model
	 * @var string
	 */
	protected $_modelName = 'structure';	
	
	/**
	 * Change access mode
	 * @return self
	 */
	public function changeAccess()
	{
		$iMenuID = Core_Array::getGet('structure_menu_id');
		$iStructureID = Core_Array::getGet('structure_id');

		$oHostDev_Menu_Structure_For_Menu = Core_Entity::factory('HostDev_Menu_Structure_For_Menu')->getByMenuIdAndStructureId($iMenuID, $iStructureID);

		!is_null($oHostDev_Menu_Structure_For_Menu)
			? $this->denyAccess()
			: $this->allowAccess();

		return $this;
	}
	

	/**
	 * Allow access to property for group
	 * @param int $structure_id structure id
	 * @return self
	 */
	public function allowAccess($structure_id = NULL)
	{
		is_null($structure_id) && $structure_id = Core_Array::getGet('structure_id');
		$structure_menu_id = Core_Array::getGet('structure_menu_id');
		// Разрешаем доп. св-во для группы
		$oHostDev_Menu_Structure_For_Menu = Core_Entity::factory('HostDev_Menu_Structure_For_Menu')->getByMenuIdAndStructureId($structure_menu_id, $structure_id);

		if (is_null($oHostDev_Menu_Structure_For_Menu))
		{
			$oHostDev_Menu_Structure_For_Menu = Core_Entity::factory('HostDev_Menu_Structure_For_Menu');
			$oHostDev_Menu_Structure_For_Menu->structure_id = $structure_id;
			$oHostDev_Menu_Structure_For_Menu->structure_menu_id = $structure_menu_id;
			$oHostDev_Menu_Structure_For_Menu->save();
		}
		return $this;
	}

	/**
	 * Deny access to property for group
	 * @param int $shop_group_id group id
	 * @return self
	 */
	public function denyAccess($structure_id = NULL)
	{
		is_null($structure_id) && $structure_id = Core_Array::getGet('structure_id');
		$structure_menu_id = Core_Array::getGet('structure_menu_id');

		$oShop_Item_Property_For_Group = Core_Entity::factory('HostDev_Menu_Structure_For_Menu')->getByMenuIdAndStructureId($structure_menu_id, $structure_id);

		if(!is_null($oShop_Item_Property_For_Group))
		{
			$oShop_Item_Property_For_Group->delete();
		}

		return $this;
	}

}